#pragma once

struct CActionCode {
	TCHAR *Name;
	DWORD Code;
};

extern CActionCode ActionCodes[];


// 11------ -------- -------- --------
//#define ACTF_ALTCODE 				0x80000000		// ignored; used to generate a different code# for the same code

// -111---- -------- -------- --------
#define ACTF_NO_DOWN  				0x40000000
#define ACTF_ON_UP  				0x20000000		
#define ACTF_ON_REPEAT				0x10000000

// -----111 -------- -------- --------
#define ACTF_F_MASK					0x0F000000
#define ACTF_F_SPECIAL				0x00000000
#define ACTF_F_KEYDOWN				0x01000000		//
#define ACTF_F_WMCOMMAND_V 			0x02000000		// to video skin
#define ACTF_F_WMCOMMAND_P	 		0x03000000		// to player skin

// -------- -------- ---11111 --------
#define ACTF_KEY_CTRL				0x00000100
//#define ACTF_KEY_ALT				0x00000200
//#define ACTF_KEY_SHIFT				0x00000400
#define ACTF_KEY_NOSFW				0x00000800

//
#define ACTF_KEY_VALUE_MASK			0x000000FF
#define ACTF_WMCOMMAND_VALUE_MASK	0x0000FFFF
#define ACTF_SPECIAL_VALUE_MASK		0x0000FFFF

#define MACT_SPECIAL(a)		(ACTF_F_SPECIAL|a)
#define MACT_KEYDOWN(a)		(ACTF_F_KEYDOWN|a)
#define MACT_WMCOMMAND_V(a)	(ACTF_F_WMCOMMAND_V|a)
#define MACT_WMCOMMAND_P(a)	(ACTF_F_WMCOMMAND_P|a)


#define ACT_NONE			0	// don't claim the code
#define ACT_IGNORE			1	// eat the code

#define ACT_PLUGINSETUP		MACT_SPECIAL(0x0011|ACTF_NO_DOWN|ACTF_ON_UP)

																						// tests

#define ACT_AUDIOLANG		MACT_KEYDOWN(ACTF_KEY_CTRL|'A'|ACTF_NO_DOWN|ACTF_ON_UP)		// dvd=v5,v6,v7
#define ACT_SUBTITLE		MACT_KEYDOWN(ACTF_KEY_CTRL|'L'|ACTF_NO_DOWN|ACTF_ON_UP)		// dvd=v5,v6,v7
#define ACT_ANGLE			MACT_KEYDOWN(ACTF_KEY_CTRL|'G'|ACTF_NO_DOWN|ACTF_ON_UP)		// dvd=v5,v6,v7

#define ACT_AUDIOCHAN		MACT_SPECIAL(0x0103)										// vcd=ok

#define ACT_TSTRETCHNORM	MACT_WMCOMMAND_P(38466)										// vcd=ok
#define ACT_TSTRETCHSLOW	MACT_WMCOMMAND_P(33933)										// vcd=ok
#define ACT_TSTRETCHFAST	MACT_WMCOMMAND_P(33932)										// vcd=ok

#define ACT_MIXVOLMUTE		MACT_SPECIAL(0x200|ACTF_ON_REPEAT)							//
#define ACT_MIXVOLUP		MACT_SPECIAL(0x201|ACTF_ON_REPEAT)							//
#define ACT_MIXVOLDN		MACT_SPECIAL(0x202|ACTF_ON_REPEAT)							//

#define ACT_VOLUMEUP		MACT_WMCOMMAND_V(34478|ACTF_ON_REPEAT)						// vcd=ok
#define ACT_VOLUMEDN		MACT_WMCOMMAND_V(34479|ACTF_ON_REPEAT)						// vcd=ok
#define ACT_VOLUMEMT		MACT_WMCOMMAND_V(34403|ACTF_ON_REPEAT)						// vcd=ok

#define ACT_PLAY			MACT_KEYDOWN(VK_RETURN	|ACTF_NO_DOWN|ACTF_ON_UP)			// vcd=ok, dvd=ok
#define ACT_PAUSE			MACT_KEYDOWN(VK_SPACE	|ACTF_NO_DOWN|ACTF_ON_UP)			// vcd=ok, dvd=ok
#define ACT_STOP			MACT_KEYDOWN(VK_END		|ACTF_NO_DOWN|ACTF_ON_UP)			// vcd=ok, dvd=ok
#define ACT_SKIPFORWARD		MACT_KEYDOWN(ACTF_KEY_CTRL|'Q'|ACTF_ON_REPEAT)				// vcd=ok, dvd=ok
#define ACT_SKIPBACKWARD	MACT_KEYDOWN(ACTF_KEY_CTRL|'B'|ACTF_ON_REPEAT)				// vcd=ok, dvd=ok
#define ACT_FFORWARD		MACT_KEYDOWN('F')											// vcd=ok, dvd=ok
#define ACT_REWIND			MACT_KEYDOWN('R')											// vcd=ok, dvd=ok
#define	ACT_STEPFORWARD		MACT_KEYDOWN('N'|ACTF_ON_REPEAT)							// vcd=ok, dvd=ok
#define ACT_STEPBACK		MACT_KEYDOWN(ACTF_KEY_CTRL|'N'|ACTF_ON_REPEAT)				// vcd=ok, dvd=ok
#define ACT_CHAPTERPREV		MACT_KEYDOWN(VK_PRIOR)										// vcd=ok, dvd=ok
#define ACT_CHAPTERNEXT		MACT_KEYDOWN(VK_NEXT)										// vcd=ok, dvd=ok

#define ACT_MENUROOT		MACT_KEYDOWN(ACTF_KEY_CTRL|'M'|ACTF_NO_DOWN|ACTF_ON_UP)		// vcd=na, dvd=ok
#define ACT_MENUTITLE		MACT_KEYDOWN(ACTF_KEY_CTRL|'T'|ACTF_NO_DOWN|ACTF_ON_UP)		// vcd=na, dvd=ok

#define ACT_ABSETA			MACT_WMCOMMAND_V(34421)										// vcd=ok
#define ACT_ABSETB			MACT_WMCOMMAND_V(34422)										// vcd=ok
#define ACT_ABCLEAR			MACT_WMCOMMAND_V(34423)										// vcd=ok

#define ACT_REPEATMODE		MACT_KEYDOWN(ACTF_KEY_CTRL|'R')								//

#define ACT_BRIGHTUP		MACT_KEYDOWN(VK_ADD|ACTF_ON_REPEAT)							//
#define ACT_BRIGHTDN		MACT_KEYDOWN(VK_SUBTRACT|ACTF_ON_REPEAT)					//

#define ACT_FULLSCREEN		MACT_KEYDOWN('Z'|ACTF_NO_DOWN|ACTF_ON_UP)					// vcd=ok
#define ACT_CAPTURE			MACT_KEYDOWN('P'|ACTF_NO_DOWN|ACTF_ON_UP)					//
#define ACT_EJECT			MACT_KEYDOWN('E'|ACTF_NO_DOWN|ACTF_ON_UP)					//
#define ACT_EXIT			MACT_KEYDOWN('X'|ACTF_NO_DOWN|ACTF_ON_UP)					//

#define ACT_0				MACT_KEYDOWN(VK_NUMPAD0)									//
#define ACT_1				MACT_KEYDOWN(VK_NUMPAD1)									//
#define ACT_2				MACT_KEYDOWN(VK_NUMPAD2)									//
#define ACT_3				MACT_KEYDOWN(VK_NUMPAD3)									//
#define ACT_4				MACT_KEYDOWN(VK_NUMPAD4)									//
#define ACT_5				MACT_KEYDOWN(VK_NUMPAD5)									//
#define ACT_6				MACT_KEYDOWN(VK_NUMPAD6)									//
#define ACT_7				MACT_KEYDOWN(VK_NUMPAD7)									//
#define ACT_8				MACT_KEYDOWN(VK_NUMPAD8)									//
#define ACT_9				MACT_KEYDOWN(VK_NUMPAD9)									//

#define ACT_UP				MACT_KEYDOWN(VK_UP|ACTF_KEY_NOSFW)
#define ACT_DOWN			MACT_KEYDOWN(VK_DOWN|ACTF_KEY_NOSFW)
#define ACT_LEFT			MACT_KEYDOWN(VK_LEFT|ACTF_KEY_NOSFW)
#define ACT_RIGHT			MACT_KEYDOWN(VK_RIGHT|ACTF_KEY_NOSFW)
#define ACT_SELECT			MACT_KEYDOWN(VK_RETURN|ACTF_KEY_NOSFW)


